diff --git a/src/main/java/net/minecraft/client/render/model/ModelCow.java b/src/main/java/net/minecraft/client/render/model/CowModel.java
similarity index 59%
rename from src/main/java/net/minecraft/client/render/model/ModelCow.java
rename to src/main/java/net/minecraft/client/render/model/CowModel.java
index 71d092f5d..c591dd67e 100644
--- a/src/main/java/net/minecraft/client/render/model/ModelCow.java
+++ b/src/main/java/net/minecraft/client/render/model/CowModel.java
@@ -2,12 +2,18 @@ package net.minecraft.client.render.model;
 
 
 // Referenced classes of package net.minecraft.src:
-//            ModelQuadruped, ModelRenderer
+//            QuadrupedModel, ModelRenderer
 
-public class ModelCow extends ModelQuadruped
+import net.minecraft.core.util.helper.MathHelper;
+
+public class CowModel extends QuadrupedModel
 {
+    Cube udders;
+    Cube horn1;
+    Cube horn2;
+
 
-    public ModelCow()
+    public CowModel()
     {
         super(12, 0.0F);
         head = new Cube(0, 0);
@@ -22,18 +28,18 @@ public class ModelCow extends ModelQuadruped
         udders = new Cube(52, 0);
         udders.addBox(-2F, -3F, 0.0F, 4, 6, 2, 0.0F);
         udders.setRotationPoint(0.0F, 14F, 6F);
-        udders.rotateAngleX = 1.570796F;
+        udders.xRot = MathHelper.PI / 2F;
         body = new Cube(18, 4);
         body.addBox(-6F, -10F, -7F, 12, 18, 10, 0.0F);
         body.setRotationPoint(0.0F, 5F, 2.0F);
-        leg1.rotationPointX--;
-        leg2.rotationPointX++;
-        leg1.rotationPointZ += 0.0F;
-        leg2.rotationPointZ += 0.0F;
-        leg3.rotationPointX--;
-        leg4.rotationPointX++;
-        leg3.rotationPointZ--;
-        leg4.rotationPointZ--;
+        leg1.x--;
+        leg2.x++;
+        leg1.z += 0.0F;
+        leg2.z += 0.0F;
+        leg3.x--;
+        leg4.x++;
+        leg3.z--;
+        leg4.z--;
     }
 
     @Override
@@ -46,16 +52,12 @@ public class ModelCow extends ModelQuadruped
     }
 
     @Override
-    public void setRotationAngles(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
     {
-        super.setRotationAngles(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
-        horn1.rotateAngleY = head.rotateAngleY;
-        horn1.rotateAngleX = head.rotateAngleX;
-        horn2.rotateAngleY = head.rotateAngleY;
-        horn2.rotateAngleX = head.rotateAngleX;
+        super.setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        horn1.yRot = head.yRot;
+        horn1.xRot = head.xRot;
+        horn2.yRot = head.yRot;
+        horn2.xRot = head.xRot;
     }
-
-    Cube udders;
-    Cube horn1;
-    Cube horn2;
 }
diff --git a/src/main/java/net/minecraft/client/render/model/CreeperModel.java b/src/main/java/net/minecraft/client/render/model/CreeperModel.java
new file mode 100644
index 000000000..de86dc9be
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/model/CreeperModel.java
@@ -0,0 +1,73 @@
+package net.minecraft.client.render.model;
+
+
+// Referenced classes of package net.minecraft.src:
+//            BaseModel, ModelRenderer, MathHelper
+
+import net.minecraft.core.util.helper.MathHelper;
+
+public class CreeperModel extends BaseModel
+{
+    public Cube head;
+    public Cube hair;
+    public Cube body;
+    public Cube leg1;
+    public Cube leg2;
+    public Cube leg3;
+    public Cube leg4;
+
+
+    public CreeperModel()
+    {
+        this(0.0F);
+    }
+
+    public CreeperModel(float expansion)
+    {
+        int yOff = 4;
+        head = new Cube(0, 0);
+        head.addBox(-4F, -6F, -4F, 8, 8, 8, expansion);
+        head.setRotationPoint(0.0F, yOff, 0.0F);
+        hair = new Cube(32, 0);
+        hair.addBox(-4F, -6F, -4F, 8, 8, 8, expansion + 0.5F);
+        hair.setRotationPoint(0.0F, yOff, 0.0F);
+        body = new Cube(16, 16);
+        body.addBox(-4F, 2.0F, -2F, 8, 12, 4, expansion);
+        body.setRotationPoint(0.0F, yOff, 0.0F);
+        leg1 = new Cube(0, 16);
+        leg1.addBox(-2F, 2.0F, -2F, 4, 6, 4, expansion);
+        leg1.setRotationPoint(-2F, 12 + yOff, 4F);
+        leg2 = new Cube(0, 16);
+        leg2.addBox(-2F, 2.0F, -2F, 4, 6, 4, expansion);
+        leg2.setRotationPoint(2.0F, 12 + yOff, 4F);
+        leg3 = new Cube(0, 16);
+        leg3.addBox(-2F, 2.0F, -2F, 4, 6, 4, expansion);
+        leg3.setRotationPoint(-2F, 12 + yOff, -4F);
+        leg4 = new Cube(0, 16);
+        leg4.addBox(-2F, 2.0F, -2F, 4, 6, 4, expansion);
+        leg4.setRotationPoint(2.0F, 12 + yOff, -4F);
+    }
+
+    @Override
+    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    {
+        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        head.render(scale);
+        body.render(scale);
+        leg1.render(scale);
+        leg2.render(scale);
+        leg3.render(scale);
+        leg4.render(scale);
+    }
+
+    @Override
+    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    {
+        head.yRot = headYaw / 57.29578F;
+        head.xRot = headPitch / 57.29578F;
+        leg1.xRot = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+        leg2.xRot = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+        leg3.xRot = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+        leg4.xRot = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/model/Cube.java b/src/main/java/net/minecraft/client/render/model/Cube.java
index 2ec5d7c8d..fc6be338a 100644
--- a/src/main/java/net/minecraft/client/render/model/Cube.java
+++ b/src/main/java/net/minecraft/client/render/model/Cube.java
@@ -11,20 +11,37 @@ import org.lwjgl.opengl.GL11;
 
 public class Cube
 {
+    private Vertex[] vertices;
+    private Polygon[] polygons;
+    private final int textureU;
+    private final int textureV;
+    private final int texWidth;
+    private final int texHeight;
+    public float x;
+    public float y;
+    public float z;
+    public float xRot;
+    public float yRot;
+    public float zRot;
+    private boolean compiled;
+    private int displayList;
+    public boolean mirror;
+    public boolean visible;
+    public boolean neverRender;
+
 
     public Cube(int u, int v, int texWidth, int texHeight)
     {
         compiled = false;
         displayList = 0;
         mirror = false;
-        showModel = true;
-        field_1402_i = false;
+        visible = true;
+        neverRender = false;
         textureU = u;
         textureV = v;
         this.texWidth = texWidth;
         this.texHeight = texHeight;
     }
-
     public Cube(int u, int v)
     {
         this(u, v, 64, 32);
@@ -42,8 +59,8 @@ public class Cube
 
     public void addBox(float minX, float minY, float minZ, int sizeX, int sizeY, int sizeZ, float expandAmount, boolean flipBottomUV)
     {
-        corners = new Vertex[8];
-        faces = new Polygon[6];
+        vertices = new Vertex[8];
+        polygons = new Polygon[6];
         float maxX = minX + (float)sizeX;
         float maxY = minY + (float)sizeY;
         float maxZ = minZ + (float)sizeZ;
@@ -67,55 +84,55 @@ public class Cube
         Vertex ptvMaxXMinYMaxZ = new Vertex(maxX, minY, maxZ, 0.0F, 8F);
         Vertex ptvMaxXMaxYMaxZ = new Vertex(maxX, maxY, maxZ, 8F, 8F);
         Vertex ptvMinXMaxYMaxZ = new Vertex(minX, maxY, maxZ, 8F, 0.0F);
-        corners[0] = ptvMinXMinYMinZ;
-        corners[1] = ptvMaxXMinYMinZ;
-        corners[2] = ptvMaxXMaxYMinZ;
-        corners[3] = ptvMinXMaxYMinZ;
-        corners[4] = ptvMinXMinYMaxZ;
-        corners[5] = ptvMaxXMinYMaxZ;
-        corners[6] = ptvMaxXMaxYMaxZ;
-        corners[7] = ptvMinXMaxYMaxZ;
-        faces[0] = new Polygon(
+        vertices[0] = ptvMinXMinYMinZ;
+        vertices[1] = ptvMaxXMinYMinZ;
+        vertices[2] = ptvMaxXMaxYMinZ;
+        vertices[3] = ptvMinXMaxYMinZ;
+        vertices[4] = ptvMinXMinYMaxZ;
+        vertices[5] = ptvMaxXMinYMaxZ;
+        vertices[6] = ptvMaxXMaxYMaxZ;
+        vertices[7] = ptvMinXMaxYMaxZ;
+        polygons[0] = new Polygon(
                 new Vertex[] { ptvMaxXMinYMaxZ, ptvMaxXMinYMinZ, ptvMaxXMaxYMinZ, ptvMaxXMaxYMaxZ },
                 textureU + sizeZ + sizeX, textureV + sizeZ,
                 textureU + sizeZ + sizeX + sizeZ, textureV + sizeZ + sizeY,
                 texWidth, texHeight
         );
-        faces[1] = new Polygon(
+        polygons[1] = new Polygon(
                 new Vertex[] { ptvMinXMinYMinZ, ptvMinXMinYMaxZ, ptvMinXMaxYMaxZ, ptvMinXMaxYMinZ },
                 textureU, textureV + sizeZ,
                 textureU + sizeZ, textureV + sizeZ + sizeY,
                 texWidth, texHeight
         );
-        faces[2] = new Polygon(
+        polygons[2] = new Polygon(
                 new Vertex[] { ptvMaxXMinYMaxZ, ptvMinXMinYMaxZ, ptvMinXMinYMinZ, ptvMaxXMinYMinZ },
                 textureU + sizeZ, textureV,
                 textureU + sizeZ + sizeX, textureV + sizeZ,
                 texWidth, texHeight
         );
         if(flipBottomUV) {
-            faces[3] = new Polygon(
+            polygons[3] = new Polygon(
                     new Vertex[] { ptvMaxXMaxYMaxZ, ptvMinXMaxYMaxZ, ptvMinXMaxYMinZ, ptvMaxXMaxYMinZ },
                     textureU + sizeZ + sizeX, textureV,
                     textureU + sizeZ + sizeX + sizeX, textureV + sizeZ,
                     texWidth, texHeight
             );
-            faces[3].invertNormal = true;
+            polygons[3].flipNormal = true;
         }else {
-            faces[3] = new Polygon(
+            polygons[3] = new Polygon(
                     new Vertex[] { ptvMaxXMaxYMinZ, ptvMinXMaxYMinZ, ptvMinXMaxYMaxZ, ptvMaxXMaxYMaxZ },
                     textureU + sizeZ + sizeX, textureV,
                     textureU + sizeZ + sizeX + sizeX, textureV + sizeZ,
                     texWidth, texHeight
             );
         }
-        faces[4] = new Polygon(
+        polygons[4] = new Polygon(
                 new Vertex[] { ptvMaxXMinYMinZ, ptvMinXMinYMinZ, ptvMinXMaxYMinZ, ptvMaxXMaxYMinZ },
                 textureU + sizeZ, textureV + sizeZ,
                 textureU + sizeZ + sizeX, textureV + sizeZ + sizeY,
                 texWidth, texHeight
         );
-        faces[5] = new Polygon(
+        polygons[5] = new Polygon(
                 new Vertex[] { ptvMinXMinYMaxZ, ptvMaxXMinYMaxZ, ptvMaxXMaxYMaxZ, ptvMinXMaxYMaxZ },
                 textureU + sizeZ + sizeX + sizeZ,
                 textureV + sizeZ, textureU + sizeZ + sizeX + sizeZ + sizeX,
@@ -123,167 +140,147 @@ public class Cube
         );
         if(mirror)
         {
-            for (Polygon face : faces) {
-                face.flipFace();
+            for (Polygon face : polygons) {
+                face.mirror();
             }
         }
     }
 
     public void setRotationPoint(float x, float y, float z)
     {
-        rotationPointX = x;
-        rotationPointY = y;
-        rotationPointZ = z;
+        this.x = x;
+        this.y = y;
+        this.z = z;
     }
 
     public void setRotationAngle(float x, float y, float z)
     {
-        rotateAngleX = x;
-        rotateAngleY = y;
-        rotateAngleZ = z;
+        xRot = x;
+        yRot = y;
+        zRot = z;
     }
 
     public void render(float scale)
     {
-        if(field_1402_i)
+        if(neverRender)
         {
             return;
         }
-        if(!showModel)
+        if(!visible)
         {
             return;
         }
         if(!compiled)
         {
-            compileDisplayList(scale);
+            compile(scale);
         }
-        if(rotateAngleX != 0.0F || rotateAngleY != 0.0F || rotateAngleZ != 0.0F)
+        if(xRot != 0.0F || yRot != 0.0F || zRot != 0.0F)
         {
             GL11.glPushMatrix();
-            GL11.glTranslatef(rotationPointX * scale, rotationPointY * scale, rotationPointZ * scale);
-            if(rotateAngleZ != 0.0F)
+            GL11.glTranslatef(x * scale, y * scale, z * scale);
+            if(zRot != 0.0F)
             {
-                GL11.glRotatef(rotateAngleZ * 57.29578F, 0.0F, 0.0F, 1.0F);
+                GL11.glRotatef(zRot * 57.29578F, 0.0F, 0.0F, 1.0F);
             }
-            if(rotateAngleY != 0.0F)
+            if(yRot != 0.0F)
             {
-                GL11.glRotatef(rotateAngleY * 57.29578F, 0.0F, 1.0F, 0.0F);
+                GL11.glRotatef(yRot * 57.29578F, 0.0F, 1.0F, 0.0F);
             }
-            if(rotateAngleX != 0.0F)
+            if(xRot != 0.0F)
             {
-                GL11.glRotatef(rotateAngleX * 57.29578F, 1.0F, 0.0F, 0.0F);
+                GL11.glRotatef(xRot * 57.29578F, 1.0F, 0.0F, 0.0F);
             }
             GL11.glCallList(displayList);
             GL11.glPopMatrix();
         } else
-        if(rotationPointX != 0.0F || rotationPointY != 0.0F || rotationPointZ != 0.0F)
+        if(x != 0.0F || y != 0.0F || z != 0.0F)
         {
-            GL11.glTranslatef(rotationPointX * scale, rotationPointY * scale, rotationPointZ * scale);
+            GL11.glTranslatef(x * scale, y * scale, z * scale);
             GL11.glCallList(displayList);
-            GL11.glTranslatef(-rotationPointX * scale, -rotationPointY * scale, -rotationPointZ * scale);
+            GL11.glTranslatef(-x * scale, -y * scale, -z * scale);
         } else
         {
             GL11.glCallList(displayList);
         }
     }
 
-    public void renderWithRotation(float f)
+    public void renderWithRotation(float scale)
     {
-        if(field_1402_i)
+        if(neverRender)
         {
             return;
         }
-        if(!showModel)
+        if(!visible)
         {
             return;
         }
         if(!compiled)
         {
-            compileDisplayList(f);
+            compile(scale);
         }
         GL11.glPushMatrix();
-        GL11.glTranslatef(rotationPointX * f, rotationPointY * f, rotationPointZ * f);
-        if(rotateAngleY != 0.0F)
+        GL11.glTranslatef(x * scale, y * scale, z * scale);
+        if(yRot != 0.0F)
         {
-            GL11.glRotatef(rotateAngleY * 57.29578F, 0.0F, 1.0F, 0.0F);
+            GL11.glRotatef(yRot * 57.29578F, 0.0F, 1.0F, 0.0F);
         }
-        if(rotateAngleX != 0.0F)
+        if(xRot != 0.0F)
         {
-            GL11.glRotatef(rotateAngleX * 57.29578F, 1.0F, 0.0F, 0.0F);
+            GL11.glRotatef(xRot * 57.29578F, 1.0F, 0.0F, 0.0F);
         }
-        if(rotateAngleZ != 0.0F)
+        if(zRot != 0.0F)
         {
-            GL11.glRotatef(rotateAngleZ * 57.29578F, 0.0F, 0.0F, 1.0F);
+            GL11.glRotatef(zRot * 57.29578F, 0.0F, 0.0F, 1.0F);
         }
         GL11.glCallList(displayList);
         GL11.glPopMatrix();
     }
 
-    public void postRender(float f)
+    public void translateTo(float scale)
     {
-        if(field_1402_i)
+        if(neverRender)
         {
             return;
         }
-        if(!showModel)
+        if(!visible)
         {
             return;
         }
         if(!compiled)
         {
-            compileDisplayList(f);
+            compile(scale);
         }
-        if(rotateAngleX != 0.0F || rotateAngleY != 0.0F || rotateAngleZ != 0.0F)
+        if(xRot != 0.0F || yRot != 0.0F || zRot != 0.0F)
         {
-            GL11.glTranslatef(rotationPointX * f, rotationPointY * f, rotationPointZ * f);
-            if(rotateAngleZ != 0.0F)
+            GL11.glTranslatef(x * scale, y * scale, z * scale);
+            if(zRot != 0.0F)
             {
-                GL11.glRotatef(rotateAngleZ * 57.29578F, 0.0F, 0.0F, 1.0F);
+                GL11.glRotatef(zRot * 57.29578F, 0.0F, 0.0F, 1.0F);
             }
-            if(rotateAngleY != 0.0F)
+            if(yRot != 0.0F)
             {
-                GL11.glRotatef(rotateAngleY * 57.29578F, 0.0F, 1.0F, 0.0F);
+                GL11.glRotatef(yRot * 57.29578F, 0.0F, 1.0F, 0.0F);
             }
-            if(rotateAngleX != 0.0F)
+            if(xRot != 0.0F)
             {
-                GL11.glRotatef(rotateAngleX * 57.29578F, 1.0F, 0.0F, 0.0F);
+                GL11.glRotatef(xRot * 57.29578F, 1.0F, 0.0F, 0.0F);
             }
         } else
-        if(rotationPointX != 0.0F || rotationPointY != 0.0F || rotationPointZ != 0.0F)
+        if(x != 0.0F || y != 0.0F || z != 0.0F)
         {
-            GL11.glTranslatef(rotationPointX * f, rotationPointY * f, rotationPointZ * f);
+            GL11.glTranslatef(x * scale, y * scale, z * scale);
         }
     }
 
-    private void compileDisplayList(float f)
+    private void compile(float scale)
     {
         displayList = GLAllocation.generateDisplayLists(1);
-        GL11.glNewList(displayList, 4864 /*GL_COMPILE*/);
+        GL11.glNewList(displayList, GL11.GL_COMPILE);
         Tessellator tessellator = Tessellator.instance;
-        for(int i = 0; i < faces.length; i++)
-        {
-            faces[i].draw(tessellator, f);
+        for (Polygon polygon : polygons) {
+            polygon.render(tessellator, scale);
         }
-
         GL11.glEndList();
         compiled = true;
     }
-
-    private Vertex[] corners;
-    private Polygon[] faces;
-    private final int textureU;
-    private final int textureV;
-    private final int texWidth;
-    private final int texHeight;
-    public float rotationPointX;
-    public float rotationPointY;
-    public float rotationPointZ;
-    public float rotateAngleX;
-    public float rotateAngleY;
-    public float rotateAngleZ;
-    private boolean compiled;
-    private int displayList;
-    public boolean mirror;
-    public boolean showModel;
-    public boolean field_1402_i;
 }
diff --git a/src/main/java/net/minecraft/client/render/model/ModelFlag.java b/src/main/java/net/minecraft/client/render/model/FlagModel.java
similarity index 95%
rename from src/main/java/net/minecraft/client/render/model/ModelFlag.java
rename to src/main/java/net/minecraft/client/render/model/FlagModel.java
index 21b558cda..dfe5e5634 100644
--- a/src/main/java/net/minecraft/client/render/model/ModelFlag.java
+++ b/src/main/java/net/minecraft/client/render/model/FlagModel.java
@@ -1,13 +1,13 @@
 package net.minecraft.client.render.model;
 
-public class ModelFlag {
+public class FlagModel {
     public Cube flagPole;
     public Cube flagPoleShort;
     public Cube flag;
     public Cube flagOverlay;
     public Cube flagBase;
 
-    public ModelFlag()
+    public FlagModel()
     {
         flagPole = new Cube(0, 0, 64, 48);
         flagPole.addBox(-1F, -22F, -1F, 2, 33, 2, 0.0F);
diff --git a/src/main/java/net/minecraft/client/render/model/GhastModel.java b/src/main/java/net/minecraft/client/render/model/GhastModel.java
new file mode 100644
index 000000000..e133d69be
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/model/GhastModel.java
@@ -0,0 +1,58 @@
+package net.minecraft.client.render.model;
+
+import net.minecraft.core.util.helper.MathHelper;
+
+import java.util.Random;
+
+// Referenced classes of package net.minecraft.src:
+//            BaseModel, ModelRenderer, MathHelper
+
+public class GhastModel extends BaseModel
+{
+
+    Cube body;
+    Cube[] tentacles;
+
+    public GhastModel()
+    {
+        tentacles = new Cube[9];
+        byte yOff = -16;
+        body = new Cube(0, 0);
+        body.addBox(-8F, -8F, -8F, 16, 16, 16);
+        body.y += 24 + yOff;
+        Random random = new Random(1660L);
+        for(int i = 0; i < tentacles.length; i++)
+        {
+            tentacles[i] = new Cube(0, 0);
+            float xo = (((((float)(i % 3) - (float)((i / 3) % 2) * 0.5F) + 0.25F) / 2.0F) * 2.0F - 1.0F) * 5F;
+            float yo = (((float)(i / 3) / 2.0F) * 2.0F - 1.0F) * 5F;
+            int len = random.nextInt(7) + 8;
+            tentacles[i].addBox(-1F, 0.0F, -1F, 2, len, 2);
+            tentacles[i].x = xo;
+            tentacles[i].z = yo;
+            tentacles[i].y = 31 + yOff;
+        }
+
+    }
+
+    @Override
+    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    {
+        for(int i = 0; i < tentacles.length; i++)
+        {
+            tentacles[i].xRot = 0.2F * MathHelper.sin(limbPitch * 0.3F + (float)i) + 0.4F;
+        }
+
+    }
+
+    @Override
+    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    {
+        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        body.render(scale);
+        for (Cube tentacle : tentacles) {
+            tentacle.render(scale);
+        }
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/model/ModelMinecart.java b/src/main/java/net/minecraft/client/render/model/MinecartModel.java
similarity index 75%
rename from src/main/java/net/minecraft/client/render/model/ModelMinecart.java
rename to src/main/java/net/minecraft/client/render/model/MinecartModel.java
index 6297a3b58..f18602867 100644
--- a/src/main/java/net/minecraft/client/render/model/ModelMinecart.java
+++ b/src/main/java/net/minecraft/client/render/model/MinecartModel.java
@@ -2,12 +2,14 @@ package net.minecraft.client.render.model;
 
 
 // Referenced classes of package net.minecraft.src:
-//            ModelBase, ModelRenderer
+//            BaseModel, ModelRenderer
 
-public class ModelMinecart extends ModelBase
+import net.minecraft.core.util.helper.MathHelper;
+
+public class MinecartModel extends BaseModel
 {
 
-    public ModelMinecart()
+    public MinecartModel()
     {
         sideModels = new Cube[7];
         sideModels[0] = new Cube(0, 10);
@@ -32,17 +34,17 @@ public class ModelMinecart extends ModelBase
         sideModels[3].setRotationPoint(0.0F, 0 + byte3, -byte2 / 2 + 1);
         sideModels[4].addBox(-byte0 / 2 + 2, -byte1 - 1, -1F, byte0 - 4, byte1, 2, 0.0F);
         sideModels[4].setRotationPoint(0.0F, 0 + byte3, byte2 / 2 - 1);
-        sideModels[0].rotateAngleX = 1.570796F;
-        sideModels[1].rotateAngleY = 4.712389F;
-        sideModels[2].rotateAngleY = 1.570796F;
-        sideModels[3].rotateAngleY = 3.141593F;
-        sideModels[5].rotateAngleX = -1.570796F;
+        sideModels[0].xRot = MathHelper.PI / 2F;
+        sideModels[1].yRot = MathHelper.PI * 1.5F;
+        sideModels[2].yRot = MathHelper.PI / 2F;
+        sideModels[3].yRot = MathHelper.PI;
+        sideModels[5].xRot = -MathHelper.PI / 2F;
     }
 
     @Override
     public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
     {
-        sideModels[5].rotationPointY = 4F - limbPitch;
+        sideModels[5].y = 4F - limbPitch;
         for(int i = 0; i < 6; i++)
         {
             sideModels[i].render(scale);
@@ -51,7 +53,7 @@ public class ModelMinecart extends ModelBase
     }
 
     @Override
-    public void setRotationAngles(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
     {
     }
 
diff --git a/src/main/java/net/minecraft/client/render/model/ModelPig.java b/src/main/java/net/minecraft/client/render/model/PigModel.java
similarity index 56%
rename from src/main/java/net/minecraft/client/render/model/ModelPig.java
rename to src/main/java/net/minecraft/client/render/model/PigModel.java
index 98c9b662e..c0098cf0a 100644
--- a/src/main/java/net/minecraft/client/render/model/ModelPig.java
+++ b/src/main/java/net/minecraft/client/render/model/PigModel.java
@@ -2,17 +2,17 @@ package net.minecraft.client.render.model;
 
 
 // Referenced classes of package net.minecraft.src:
-//            ModelQuadruped
+//            QuadrupedModel
 
-public class ModelPig extends ModelQuadruped
+public class PigModel extends QuadrupedModel
 {
 
-    public ModelPig()
+    public PigModel()
     {
         this(0.0F);
     }
 
-    public ModelPig(float f)
+    public PigModel(float f)
     {
         super(6, f);
         nose = new Cube(16, 16);
@@ -27,10 +27,10 @@ public class ModelPig extends ModelQuadruped
     }
 
     @Override
-    public void setRotationAngles(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale) {
-        super.setRotationAngles(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
-        nose.rotateAngleX = headPitch / 57.29578F;
-        nose.rotateAngleY = headYaw / 57.29578F;
+    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale) {
+        super.setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        nose.xRot = headPitch / 57.29578F;
+        nose.yRot = headYaw / 57.29578F;
     }
 
     public Cube nose;
diff --git a/src/main/java/net/minecraft/client/render/model/PlayerModel.java b/src/main/java/net/minecraft/client/render/model/PlayerModel.java
new file mode 100644
index 000000000..da3e632f2
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/model/PlayerModel.java
@@ -0,0 +1,95 @@
+package net.minecraft.client.render.model;
+
+import org.lwjgl.opengl.GL11;
+
+public class PlayerModel extends BipedModel {
+
+    public Cube bipedLeftArmOverlay;
+    public Cube bipedRightArmOverlay;
+    public Cube bipedLeftLegOverlay;
+    public Cube bipedRightLegOverlay;
+    public Cube bipedBodyOverlay;
+
+    public PlayerModel(float expansion){
+        this(expansion, 0.0F);
+    }
+
+    public PlayerModel(float expansion, float yRotOffset){
+        holdingLeftHand = false;
+        holdingRightHand = false;
+        sneaking = false;
+        cloak = new Cube(0, 0, 64, 32);
+        cloak.addBox(-5F, 0.0F, -1F, 10, 16, 1, expansion, true);
+        ear = new Cube(24, 0, 64, 64);
+        ear.addBox(-3F, -6F, -1F, 6, 6, 1, expansion, true);
+        bipedLeftArmOverlay = new Cube(48, 48, 64, 64);
+        bipedLeftArmOverlay.addBox(-1.0F, -2.0F, -2.0F, 4, 12, 4, expansion + 0.25F, true);
+        bipedLeftArmOverlay.setRotationPoint(5.0F, 2.0F, 0.0F);
+        bipedRightArmOverlay = new Cube(40, 32, 64, 64);
+        bipedRightArmOverlay.addBox(-3.0F, -2.0F, -2.0F, 4, 12, 4, expansion + 0.25F, true);
+        bipedRightArmOverlay.setRotationPoint(-5.0F, 2.0F, 10.0F);
+        bipedLeftLegOverlay = new Cube(0, 48, 64, 64);
+        bipedLeftLegOverlay.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, expansion + 0.25F, true);
+        bipedLeftLegOverlay.setRotationPoint(1.9F, 12.0F, 0.0F);
+        bipedRightLegOverlay = new Cube(0, 32, 64, 64);
+        bipedRightLegOverlay.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, expansion + 0.25F, true);
+        bipedRightLegOverlay.setRotationPoint(-1.9F, 12.0F, 0.0F);
+        bipedBodyOverlay = new Cube(16, 32, 64, 64);
+        bipedBodyOverlay.addBox(-4.0F, 0.0F, -2.0F, 8, 12, 4, expansion + 0.25F, true);
+        bipedBodyOverlay.setRotationPoint(0.0F, 0.0F, 0.0F);
+        this.arm1 = new Cube(32, 48, 64, 64);
+        this.arm1.addBox(-1.0F, -2.0F, -2.0F, 4, 12, 4, expansion, true);
+        this.arm1.setRotationPoint(5.0F, 2.0F, 0.0F);
+        this.leg1 = new Cube(16, 48, 64, 64);
+        this.leg1.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, expansion, true);
+        this.leg1.setRotationPoint(1.9F, 12.0F, 0.0F);
+        head = new Cube(0, 0, 64, 64);
+        head.addBox(-4F, -8F, -4F, 8, 8, 8, expansion, true);
+        head.setRotationPoint(0.0F, 0.0F + yRotOffset, 0.0F);
+        hair = new Cube(32, 0, 64, 64);
+        hair.addBox(-4F, -8F, -4F, 8, 8, 8, expansion + 0.5F, true);
+        hair.setRotationPoint(0.0F, 0.0F + yRotOffset, 0.0F);
+        body = new Cube(16, 16, 64, 64);
+        body.addBox(-4F, 0.0F, -2F, 8, 12, 4, expansion, true);
+        body.setRotationPoint(0.0F, 0.0F + yRotOffset, 0.0F);
+        arm0 = new Cube(40, 16, 64, 64);
+        arm0.addBox(-3F, -2F, -2F, 4, 12, 4, expansion, true);
+        arm0.setRotationPoint(-5F, 2.0F + yRotOffset, 0.0F);
+        leg0 = new Cube(0, 16, 64, 64);
+        leg0.addBox(-2F, 0.0F, -2F, 4, 12, 4, expansion, true);
+        leg0.setRotationPoint(-2F, 12F + yRotOffset, 0.0F);
+    }
+
+    @Override
+	public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale){
+        super.render(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        GL11.glPushMatrix();
+        bipedLeftArmOverlay.render(scale);
+        bipedRightArmOverlay.render(scale);
+        bipedLeftLegOverlay.render(scale);
+        bipedRightLegOverlay.render(scale);
+        bipedBodyOverlay.render(scale);
+        GL11.glPopMatrix();
+    }
+
+    @Override
+	public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale){
+        super.setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        copyTranslation(this.leg1, this.bipedLeftLegOverlay);
+        copyTranslation(this.leg0, this.bipedRightLegOverlay);
+        copyTranslation(this.arm1, this.bipedLeftArmOverlay);
+        copyTranslation(this.arm0, this.bipedRightArmOverlay);
+        copyTranslation(this.body, this.bipedBodyOverlay);
+    }
+
+    public static void copyTranslation(Cube sourceCube, Cube destinationCube)
+    {
+        destinationCube.xRot = sourceCube.xRot;
+        destinationCube.yRot = sourceCube.yRot;
+        destinationCube.zRot = sourceCube.zRot;
+        destinationCube.x = sourceCube.x;
+        destinationCube.y = sourceCube.y;
+        destinationCube.z = sourceCube.z;
+    }
+
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/client/render/model/PlayerSlimModel.java b/src/main/java/net/minecraft/client/render/model/PlayerSlimModel.java
new file mode 100644
index 000000000..3e6238cc8
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/model/PlayerSlimModel.java
@@ -0,0 +1,26 @@
+package net.minecraft.client.render.model;
+
+public class PlayerSlimModel extends PlayerModel {
+
+    public PlayerSlimModel(float f) {
+        this(f, 0f);
+    }
+
+    public PlayerSlimModel(float expansion, float yRotOffset){
+        super(expansion, yRotOffset);
+        bipedLeftArmOverlay = new Cube(48, 48, 64, 64);
+        bipedLeftArmOverlay.addBox(-1.0F, -2.0F, -2.0F, 3, 12, 4, expansion + 0.25F);
+        bipedLeftArmOverlay.setRotationPoint(5.0F, 2.5F, 0.0F);
+        bipedRightArmOverlay = new Cube(40, 32, 64, 64);
+        bipedRightArmOverlay.addBox(-2.0F, -2.0F, -2.0F, 3, 12, 4, expansion + 0.25F);
+        bipedRightArmOverlay.setRotationPoint(-5.0F, 2.5F, 10.0F);
+        arm1 = new Cube(32, 48, 64, 64);
+        arm1.addBox(-1.0F, -2.0F, -2.0F, 3, 12, 4, expansion);
+        arm1.setRotationPoint(5.0F, 2.5F, 0.0F);
+        arm0 = new Cube(40, 16, 64, 64);
+        arm0.addBox(-2F, -2F, -2F, 3, 12, 4, expansion);
+        arm0.setRotationPoint(-5F, 2.5F + yRotOffset, 0.0F);
+
+    }
+
+}
\ No newline at end of file
